import scipy.fft as sf
from scipy import fft as sf
import random
from random import randint
from PIL import Image
import cv2
import cv2 as cv
import numpy as np

print("*"*70)
print("Hello World")
############################RSA################################


def isprime(n):
    # تشخیص عدد اول
    if n <= 1:
        return False
    elif n <= 3:
        return True
    if (n % 2 == 0 or n % 3 == 0):
        return False
    i = 5
    while (i * i <= n):
        if (n % i == 0 or n % (i + 2) == 0):
            return False
        i = i + 6
    return True


def gcd(a, b):
    # محاسبه ب.م.م از طریق الگوریتم اقلیدوسی
    if b == 0:
        return a
    else:
        return gcd(b, a % b)


def mod_inverse(a, m):
    # محاسبه وارون ضربی پیمانه ای
    # باقیمانده‌ی حاصلضرب e*d به n = 1
    for x in range(1, m):
        if (a * x) % m == 1:
            return x
    return -1


p = randint(1, 1000)
q = randint(1, 1000)


def generate_keypair(p, q):
    # keysize : طول کلید
    # x << y برابر است با x * 2**y

    primes = []
    for i in range(1, 1000, 1):
        if isprime(i) == True:
            primes.append(i)

    # از بین اعداد اول تولید شده دو عدد تصادفی انتخاب میکنیم
    while primes != []:
        p = random.choice(primes)
        primes.remove(p)  # p != q
        q = random.choice(primes)
        break
    # print(f"p:{p} , q:{q}")
    n = p * q
    t = (p - 1) * (q - 1)
    # φ(n) = lcm (p-1 ,q-1) = |(p-1)*(q-1)| / gcd(p-1,q-1)

    while True:
        #  1 < e < phi(n) and gcd(e,phi) = 1
        # اگه ب.م.م دو عدد یک باشه میگیم این دو عدد نسبت به هم اولند
        e = random.randrange(1, t)
        g = gcd(e, t)
        # d*e ≡ 1 (mod n)
        d = mod_inverse(e, t)
        if g == 1 and e != d:
            break

    # public key = (e , n)
    # private key = (d , n)
    # e ~ encryption
    # d ~ decryption

    return ((e, n), (d, n))


public, private = generate_keypair(p, q)


def encrypt(Massage, package):
    # c = m^e  mod n
    # pow(base, exp, mod) -> base^exp % mod
    e, n = package
    msg_secrettext = [pow(ord(x), e, n) for x in Massage]
    return msg_secrettext


def decrypt(msg_secrettext, d, n):
    # m = c^d  mod
    Massage = [chr(pow(x, d, n)) for x in msg_secrettext]
    return (''.join(Massage))


def RSA(a):
    if a == 1:
        print('''\nOk Dear! Your Message Is Encrypted By The RSA System
            ''')
        msg = input("Write Your Msg: ")
        print(f"Public Key :> {public}")
        print(f"Private Key :> {private}")
        global encrypted_msg
        encrypted_msg = encrypt(msg, public)
        print(
            f"Encrypted msg :> {''.join(map(lambda x: str(x), encrypted_msg))} ")
        global EncryptedMsg
        EncryptedMsg = ''.join(map(lambda x: str(x), encrypted_msg))
    else:
        encrypted_msg = encrypt(msg, public)
        print('''\nYour Message Is Decrypted By The RSA System
            ''')
        print("Please Enter Your Private Key (D,N) : ")
        D = input("D : ")
        N = input("N : ")
        print(
            f"Decrypted msg :> {decrypt(encrypted_msg, d=int(D),n=int(N))} ")

############################LSB################################


def data2binary(data):
    # تبدیل هر نوع داده دریافتی به باینری
    if type(data) == str:
        p = ''.join([format(ord(i), '08b')for i in data])
    elif type(data) == bytes or type(data) == np.ndarray:
        p = [format(i, '08b')for i in data]
    elif type(data) == int:
        p = format(data, "08b")
    else:
        return ValueError("Input Type Not Supported")
    return p


def hidedata(img, data):
    data += "$$"  # میتوان از هر رشته ای برای جداسازی استفاده کرد
    d_index = 0
    binary_data = data2binary(data)
    len_data = len(binary_data)

    for value in img:
        for pix in value:
            r, g, b = data2binary(pix)
            # تا زمانی که داده برای ذخیره سازی وجود دارد ادامه می دهیم
            # r[:-1] : اخرین داده لیست
            if d_index < len_data:
                pix[0] = int(r[:-1] + binary_data[d_index])
                d_index += 1
            if d_index < len_data:
                pix[1] = int(g[:-1] + binary_data[d_index])
                d_index += 1
            if d_index < len_data:
                pix[2] = int(b[:-1] + binary_data[d_index])
                d_index += 1
            if d_index >= len_data:
                break
    return img


def encode():
    img_name = input("\Enter Image FileName For Steganography:")
    image1 = cv2.imread(img_name)
    image2 = sf.dct(image1)
    image = image2.astype(int)
    img = Image.open(img_name, 'r')
    w, h = img.size
    data = EncryptedMsg
    if data == 0:
        raise ValueError('Empty Data')
    enc_img = input("\Enter Stego Image Name For Saving:")
    enc_data = hidedata(image, data)
    cv2.imwrite(enc_img, enc_data)
    img1 = Image.open(enc_img, 'r')
    img1 = img1.resize((w, h), Image.ANTIALIAS)
    if w != h:
        img1.save(enc_img, optimize=True, quality=65)
    else:
        img1.save(enc_img)


def find_data(img):
    bin_data = ""
    for value in img:
        for pix in value:
            r, g, b = data2binary(pix)
            # خارج کردن داده از آخرین بیت هر پیکسل
            bin_data += r[-1]
            bin_data += g[-1]
            bin_data += b[-1]
    all_bytes = [bin_data[i:i+8]for i in range(0, len(bin_data), 8)]

    decoded_data = ''
    for x in all_bytes:
        decoded_data += chr(int(x, 2))
        if decoded_data[-2:] == "$$":
            break

    return decoded_data[:-2]


def decode():
    image_name = input('\Enter Image FileName That You Want DeCoding :')
    image1 = cv2.imread(image_name)
    image2 = sf.idct(image1)
    image = image2.astype(int)
    img = Image.open(image_name, 'r')
    msg = find_data(image)
    return msg


def steganography():

    print('''\nImage Stego
            1.encode 
            2.decode''')
    u_in = int(input('\n Your Num? '))
    if u_in == 1:
        print("\nEncoding ...")

        RSA(1)
        encode()
    elif u_in == 2:
        print("\nDecoding ...")
        global ans
        ans = decode()
        RSA(2)
    else :
        raise ValueError("Enter Correct input")

steganography()